# Contributing Guidelines

We hope you are enjoying Docker and look forward to hearing your feedback. Whether you want to raise a bug report, a feature request or just request a correction to something, we really value our community input.

We do ask that you read this document and send us any issues or raise pull requests to make sure we understand clearly what you are asking for. This will help ensure we are making the right decisions and taking the right actions.

## Feature Requests

You are very welcome to create new issues on this project to request new features in any of Docker products.

If you would like to suggest a new feature, we ask that you please use our issue template. This contains a few essential questions that help us understand the problem you are looking to solve and how you think your recommendation will address it. We also tag incoming issues from this template with "community_new". This lets our teams quickly see what has been raised and better address the community recommendations.

To see what has already been proposed by the community you can look [here](https://github.com/docker/docker-roadmap/labels/community_new).

"Watch out for duplicates!" If you are creating a new issue, please check [existing open](https://github.com/docker/docker-roadmap/issues), or [recently closed](https://github.com/docker/docker-roadmap/issues?utf8=%E2%9C%93&q=is%3Aissue%20is%3Aclosed%20) . Having a single voted for issue is far easier for us to prioritize 

## Reporting Bugs

We would ask that you please don't use this repo to raise bugs. Each of our products has it's own repo where issues relating to that product are raised. We have chosen to do this as our products are all quite different, and as a result we need quite different information for each product to best understand how to help you.

To raise a bug please use:
* [Docker Hub](https://github.com/docker/hub-feedback/issues/new)
* [Docker Desktop Windows](https://github.com/docker/for-win/issues/new)
* [Docker Desktop Mac](https://github.com/docker/for-mac/issues/new)
* [Docker Engine](https://github.com/docker/for-linux/issues/new)
* [docker-compose](https://github.com/docker/compose/issues/new)
* [Docker Build Cloud](https://github.com/docker/build-cloud-feedback/issues)



## Security issue notifications
Please do **not** create a public github issue.
If you discover a potential security issue in this project we ask that you notify Docker Security send your report privately to security@docker.com. Please do **not** create a public github issue.


## Licensing

See the [LICENSE](https://github.com/docker/docker-roadmap/blob/master/LICENSE) file for our project's licensing. We will ask you to confirm the licensing of your contribution.

We may ask you to sign a [Contributor License Agreement (CLA)](http://en.wikipedia.org/wiki/Contributor_License_Agreement) for larger changes.
